searchNodes=[{"doc":"A function decorator for OpenTelemetry traces. Usage The event name can be any string. defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate trace(&quot;my_app.worker.do_work&quot;) def do_work(arg1, arg2) do ...doing work do_more_work(arg1) end @decorate trace(&quot;MyApp::Worker::do_work&quot;) def do_more_work(arg1) do ...doing more work end end We use OpenTelemetry.Tracer.current_span_ctx() to automatically link new spans to the current trace (if it exists and is in the same process). So the above example will link the do_work and do_more_work spans for you by default. You can provide span attributes by specifying a list of variable names as atoms. This list can include... Any variables (in the top level closure) available when the function exits: defmodule MyApp.Math do use OpenTelemetryDecorator @decorate trace(&quot;my_app.math.add&quot;, [:a, :b, :sum]) def add(a, b) do sum = a + b {:ok, thing1} end end The result of the function by including the atom :result: defmodule MyApp.Math do use OpenTelemetryDecorator @decorate trace(&quot;my_app.math.add&quot;, [:result]) def add(a, b) do sum = a + b {:ok, thing1} end end Map/struct properties using nested lists of atoms: defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate trace(&quot;my_app.worker.do_work&quot;, [[:arg1, :count], [:arg2, :count], :total]) def do_work(arg1, arg2) do total = arg1.count + arg2.count {:ok, total} end end Installation Add open_telemetry_decorator to your list of dependencies in mix.exs and do a mix deps.get: def deps do [ {:open_telemetry_decorator, &quot;~&gt; 0.1.0&quot;} ] end","ref":"OpenTelemetryDecorator.html","title":"OpenTelemetryDecorator","type":"module"},{"doc":"This method has to be public because it&#39;s used within the macro, but it shouldn&#39;t be called directly.","ref":"OpenTelemetryDecorator.html#get_reportable_attrs/3","title":"OpenTelemetryDecorator.get_reportable_attrs/3","type":"function"},{"doc":"","ref":"OpenTelemetryDecorator.html#trace/1","title":"OpenTelemetryDecorator.trace/1","type":"macro"},{"doc":"","ref":"OpenTelemetryDecorator.html#trace/2","title":"OpenTelemetryDecorator.trace/2","type":"macro"},{"doc":"Decorate a function to add an OpenTelemetry trace with a named span. You can provide span attributes by specifying a list of variable names as atoms. This list can include: any variables (in the top level closure) available when the function exits, the result of the function by including the atom :result, map/struct properties using nested lists of atoms. defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate trace(&quot;my_app.worker.do_work&quot;, [:arg1, [:arg2, :count], :total, :result]) def do_work(arg1, arg2) do total = arg1.count + arg2.count {:ok, total} end end","ref":"OpenTelemetryDecorator.html#trace/4","title":"OpenTelemetryDecorator.trace/4","type":"function"},{"doc":"This method has to be public because it&#39;s used within the macro, but it shouldn&#39;t be called directly.","ref":"OpenTelemetryDecorator.html#validate_args/2","title":"OpenTelemetryDecorator.validate_args/2","type":"function"}]